%define anolis_release 1
%define abidir %{_prefix}/lib/compatibility/%{name}

Name:		dml
Version:	0.1.9~beta
Release:	%{anolis_release}%{?dist}
Summary:	Intel® Data Mover Library (Intel® DML)
License:	MIT
URL:		https://github.com/intel/DML
Source0:	https://github.com/intel/DML/archive/refs/tags/v0.1.9-beta.tar.gz

Patch1001:	1001-bugfix-build-error-in-gcc-12.patch
Patch1002: 	1002-remove-googletest-in-source.patch
Patch1003:	1003-remove-werror-to-fix-build-error.patch

BuildRequires:	accel-config > 3.2 kernel-devel > 5.10
BuildRequires:	gcc-c++ cmake gcc
BuildRequires:  libuuid-devel
BuildRequires:  doxygen
BuildRequires:  python3-devel
BuildRequires:  gmock-devel gtest-devel

ExclusiveArch:  x86_64

%package devel
Summary:	header files for %{name}.
Requires:	%{name} = %{version}-%{release}

%description devel
Header file for %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%description
Intel® Data Mover Library (Intel® DML) is an open-source library to provide 
high-performance data manipulation on Intel CPUs. Intel® DML is intended for 
streaming data movement and transformation operations optimization that is 
applicable for effective storage, networking, persistent memory, and various 
data processing applications.

%prep
%autosetup -n DML-0.1.9-beta -p1

%build
%cmake
%cmake_build

%install
%cmake_install

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
find $RPM_BUILD_ROOT -name '*.a' -exec rm -f {} ';'

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{buildroot}/%{_libdir}
mkdir -p %{buildroot}/%{abidir}
pushd %{buildroot}/%{abidir}
for dir in %{_sbindir} %{_bindir} ; do
        for f in $(ls %{buildroot}/$dir) ; do
                full_name=%{buildroot}/$dir/$f
                (file $full_name | grep executable > /dev/null 2>&1 && $full_name --help > $f-option.list > /dev/null 2>&1) || echo "ok"
        done
done

%files
%license LICENSE
%doc CODEOWNERS
%dir %{abidir}
%{_bindir}/dml_test_*
%{_bindir}/tests
%{_bindir}/tests_mt
%{_bindir}/job_api_samples
%{abidir}/*-option.list

%files devel
%{_includedir}/dml/*
%{_libdir}/cmake/Dml/*.cmake

%files doc
%doc README.md SECURITY.md CONTRIBUTING.md 

%changelog
* Wed Aug 03 2022 happy_orange <songnannan@linux.alibaba.com> - 0.1.9~beta-1
- Init package from upstream
